
----------------------------------------------
-- shield thinker

local srb2shields = {MT_PITYORB, MT_BLUEORB, MT_WHITEORB, MT_BLACKORB, MT_YELLOWORB, MT_GREENORB}
for _,i in pairs(srb2shields) do
addHook("MobjThinker", function(mobj)
    if cv_powerlap.value
    for player in players.iterate do
        if not (player.powerlap) continue end;
        local shield = player.powerlap.shield
        --if not player.powerlap.shield.valid player.powerlap.shield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_PITYORB) end;
        if shield == nil or not shield.valid continue end;
        if player.powers[pw_shield] == SH_NONE P_RemoveMobj(shield) continue end;

        
        shield.target = player.mo;
        shield.tracer = player.mo;
        shield.colorized = false;
        shield.color = player.skincolor;
        
        if player.kartstuff[k_growshrinktimer] > 0 shield.destscale = mapheaderinfo[gamemap].mobj_scale + (mapheaderinfo[gamemap].mobj_scale*2)/2
        elseif player.kartstuff[k_growshrinktimer] < 0 shield.destscale = mapheaderinfo[gamemap].mobj_scale + mapheaderinfo[gamemap].mobj_scale/6
        else shield.destscale = mapheaderinfo[gamemap].mobj_scale + mapheaderinfo[gamemap].mobj_scale/3 end
        --P_InstaThrust(mobj, player.mo.angle, player.speed)
        
        --print(shield.scale)
        --if player.powers[pw_shield] == SH_NONE P_RemoveMobj(mobj) end;
        P_TeleportMove(shield, player.mo.x, player.mo.y, player.mo.z)
    end
    end
end, i)
end
-- shields
-- MT_PITYORB -- normal shield
-- MT_BLUEORB -- force shield
-- MT_WHITEORB -- whirlwind shield
-- MT_BLACKORB -- Armageddon shield
-- MT_YELLOWORB -- attract shield
-- MT_GREENORB -- elemental shield

----------------------------------------------
-- shield removal function
local function checkshield(player)
    if player.powerlap.item == plap.powitems.protectshield
     and player.kartstuff[k_invincibilitytimer] == 0 and player.kartstuff[k_growshrinktimer] <= 0
     and player.kartstuff[k_hyudorotimer] == 0 and player.powers[pw_flashing] == 0
        local shield = player.powerlap.shield
        K_DoInstashield(player)
        player.powers[pw_shield] = SH_NONE
        player.powers[pw_flashing] = TICRATE * 3
        player.powerlap.item = 0
        player.powerlap.discardtime = 0
        P_RemoveMobj(shield);
        shield = nil;
        --print("aaaaaaaa");
        return true
    end
return 
end


addHook("ShouldSpin", function(player, inflicator, source)
    if cv_powerlap.value
        --recollectpow(player, inflicator, source)
        if checkshield(player) -- cancel damage if the player has a shield
        if hitfeed -- hitfeed indication
            -- don't forget source is a mobj
            local sourcetable = {{source.player.name, source.hf_overridenamecolor or source.player.skincolor}, {skins[source.skin].facemmap, source.player.skincolor}, source.player}
            local victimtable = {{player.name, player.mo.hf_overridenamecolor or player.skincolor}, {skins[player.mo.skin].facemmap, player.skincolor}, player}
            if (player == source.player) sourcetable = {{nil, nil}, {nil, nil}, nil} end
            HF_SendHitMessage(sourcetable, victimtable, "POWLI_SB")
        end
        return false 
        else return nil end
    end
end)
addHook("ShouldSquish", function(player, inflicator, source)
    if cv_powerlap.value
        if checkshield(player) -- cancel damage if the player has a shield
        if hitfeed -- hitfeed indication
            -- don't forget source is a mobj
            local sourcetable = {{source.player.name, source.hf_overridenamecolor or source.player.skincolor}, {skins[source.skin].facemmap, source.player.skincolor}, source.player}
            local victimtable = {{player.name, player.mo.hf_overridenamecolor or player.skincolor}, {skins[player.mo.skin].facemmap, player.skincolor}, player}
            if (player == source.player) sourcetable = {{nil, nil}, {nil, nil}, nil} end
            HF_SendHitMessage(sourcetable, victimtable, "POWLI_SB")
        end
        return false 
        else return nil end
    end
end)

addHook("ShouldExplode", function(player, inflicator, source)
    if cv_powerlap.value
        if inflicator.extravalue1 == 1 then return true -- does not cancel damage on spb
        elseif checkshield(player) -- cancel damage if the player has a shield
        if hitfeed -- hitfeed indication
            -- don't forget source is a mobj
            local sourcetable = {{source.player.name, source.hf_overridenamecolor or source.player.skincolor}, {skins[source.skin].facemmap, source.player.skincolor}, source.player}
            local victimtable = {{player.name, player.mo.hf_overridenamecolor or player.skincolor}, {skins[player.mo.skin].facemmap, player.skincolor}, player}
            if (player == source.player) sourcetable = {{nil, nil}, {nil, nil}, nil} end
            HF_SendHitMessage(sourcetable, victimtable, "POWLI_SB")
        end
        return false 
        else return nil end
    end
end)


----------------------------------------------
-- item recollect hook function
local function recollectpow(player, objsource, attacker)
if cv_powerlap.value
    --print(objsource.type)
    --print("ddez:" + attacker.type)
    if player.powerlap.item == plap.powitems.itemrecollect and player.powerlap.collectitem == nil
    -- give the corresponding item
    if     objsource.type == MT_BANANA player.powerlap.collectitem = KITEM_BANANA
    elseif objsource.type == MT_ORBINAUT --
     or    objsource.type == MT_ORBINAUT_SHIELD player.powerlap.collectitem = KITEM_ORBINAUT
    elseif objsource.type == MT_JAWZ --
     or    objsource.type == MT_JAWZ_SHIELD --
     or    objsource.type == MT_JAWZ_DUD player.powerlap.collectitem = KITEM_JAWZ
    elseif objsource.type == MT_BALLHOG player.powerlap.collectitem = KITEM_BALLHOG
    elseif objsource.type == 450 --
     or    objsource.type == MT_MINEEXPLOSION player.powerlap.collectitem = KITEM_MINE
    elseif objsource.type == MT_SPBEXPLOSION player.powerlap.collectitem = KITEM_EGGMAN
    elseif objsource.type == MT_PLAYER -- player collision
            if objsource.player.kartstuff[k_invincibilitytimer] > 0 player.powerlap.collectitem = KITEM_INVINCIBILITY
            elseif objsource.player.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD player.powerlap.collectitem = KITEM_THUNDERSHIELD
            elseif objsource.player.kartstuff[k_growshrinktimer] > 0 player.powerlap.collectitem = KITEM_GROW
            else player.powerlap.collectitem = KITEM_SNEAKER
            end
    end

    player.powerlap.powtime = 2
    end
end
end

addHook("PlayerSpin", recollectpow, curseeffect)
addHook("PlayerExplode", recollectpow)
addHook("PlayerSquish", recollectpow)

----------------------------------------------
-- curse attack hook function
local function curseeffect(player, objsource, attacker) -- shrinks the victim
    if cv_powerlap.value
        if objsource == nil or attacker == nil return end;
        if player == attacker.player return end; -- don't shrink on self hit 
        if attacker.player.powerlap.item == plap.powitems.curseattack
            player.kartstuff[k_growshrinktimer] = -TICRATE * 7
            player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*4)/6; --75%
            S_StartSound(player.mo, sfx_kc59)
            -- give a 2 sec decay before losing the pow, attacker can affect multiple victims in a row
            --attacker.player.powerlap.powtime = TICRATE * 2
            if (mapheaderinfo[gamemap].numlaps <= 2) attacker.player.powerlap.powtime =  TICRATE * 5
                    elseif (mapheaderinfo[gamemap].numlaps == 3) attacker.player.powerlap.powtime =  TICRATE * 2 + TICRATE/2
                    elseif (mapheaderinfo[gamemap].numlaps == 4) attacker.player.powerlap.powtime =  TICRATE * 2
                    elseif (mapheaderinfo[gamemap].numlaps >= 5) attacker.player.powerlap.powtime =  TICRATE * 1 + TICRATE/2
                    else player.powerlap.powtime =  TICRATE * 2 end
            attacker.player.powerlap.inuse = true
            
            if hitfeed -- hitfeed indication
                -- don't forget source is a mobj
                local sourcetable = {{attacker.player.name, attacker.hf_overridenamecolor or attacker.player.skincolor}, {skins[attacker.skin].facemmap, attacker.player.skincolor}, attacker.player}
                local victimtable = {{player.name, player.mo.hf_overridenamecolor or player.skincolor}, {skins[player.mo.skin].facemmap, player.skincolor}, player}
                if (player == attacker.player) sourcetable = {{nil, nil}, {nil, nil}, nil} end
                HF_SendHitMessage(sourcetable, victimtable, "POWLI_C")
            end
        end
    end
end

addHook("PlayerSpin", curseeffect)
addHook("PlayerExplode", curseeffect)
addHook("PlayerSquish", curseeffect)

local function curserocketCollision(mo, mo2)
if cv_powerlap.value
    -- collision must happen
    if (mo.z + mo.height >= mo2.z) and (mo.z <= mo2.z + mo2.height)
        if not (mo.player) and (mo.valid) return end
        if not (mo2.player) and (mo2.valid) return end

        -- curse attack check
        if mo.player.powerlap.item != plap.powitems.curseattack return end
        if mo.player.kartstuff[k_rocketsneakertimer] == 0 return end

        -- invincibilities just don't execute the code
        if mo.player.kartstuff[k_growshrinktimer] != 0 or mo2.player.kartstuff[k_growshrinktimer] != 0 return end
        if mo.player.kartstuff[k_invincibilitytimer] != 0 or mo2.player.kartstuff[k_invincibilitytimer] != 0 return end
        if mo.player.powers[pw_flashing] != 0 or mo2.player.powers[pw_flashing] != 0 return end
        if mo.player.kartstuff[k_hyudorotimer] != 0 or mo2.player.kartstuff[k_hyudorotimer] != 0 return end

        if hitfeed -- hitfeed indication
                -- don't forget source is a mobj
                local sourcetable = {{mo.player.name, mo.hf_overridenamecolor or mo.player.skincolor}, {skins[mo.skin].facemmap, mo.player.skincolor}, mo.player}
                local victimtable = {{mo2.player.name, mo2.hf_overridenamecolor or mo2.player.skincolor}, {skins[mo2.skin].facemmap, mo2.player.skincolor}, mo2.player}
                --if (player == source.player) sourcetable = {{nil, nil}, {nil, nil}, nil} end
                HF_SendHitMessage(sourcetable, victimtable, "POWLI_C")
		end
        K_SpinPlayer(mo2.player, mo, 1, mo, false)
    end
end
end

addHook("MobjCollide", curserocketCollision, MT_PLAYER)
addHook("MobjMoveCollide", curserocketCollision, MT_PLAYER)

----------------------------------------------
-- punch bumper collision
local function punchbumperCollision(mo, mo2)
if cv_powerlap.value
    -- collision must happen
    if (mo.z + mo.height >= mo2.z) and (mo.z <= mo2.z + mo2.height)
        if not (mo.player) and (mo.valid) return end
        if not (mo2.player) and (mo2.valid) return end
        if mo2.player.powerlap.item == plap.powitems.punchbumper return end

        if mo.player.powerlap.item == plap.powitems.punchbumper 
         and mo.player.powerlap.inuse == true

            -- should make the victim jump on hit
            if mo2.player.kartstuff[k_spinouttimer] != 0 P_SetObjectMomZ(mo2, FRACUNIT*15, false) end

            -- invincibilities just don't execute the code
            if mo.player.kartstuff[k_growshrinktimer] > 0 or mo2.player.kartstuff[k_growshrinktimer] > 0 return end
            if mo.player.kartstuff[k_invincibilitytimer] != 0 or mo2.player.kartstuff[k_invincibilitytimer] != 0 return end
            --if mo.player.powers[pw_flashing] != 0 or mo2.player.powers[pw_flashing] != 0 return end
            if mo.player.kartstuff[k_hyudorotimer] != 0 or mo2.player.kartstuff[k_hyudorotimer] != 0 return end


            if mo2.player.kartstuff[k_spinouttimer] == 0 and mo2.player.powers[pw_flashing] == 0
            if hitfeed -- hitfeed indication
                -- don't forget source is a mobj
                local sourcetable = {{mo.player.name, mo.hf_overridenamecolor or mo.player.skincolor}, {skins[mo.skin].facemmap, mo.player.skincolor}, mo.player}
                local victimtable = {{mo2.player.name, mo2.hf_overridenamecolor or mo2.player.skincolor}, {skins[mo2.skin].facemmap, mo2.player.skincolor}, mo2.player}
                --if (player == source.player) sourcetable = {{nil, nil}, {nil, nil}, nil} end
                HF_SendHitMessage(sourcetable, victimtable, "POWLI_PB")
			end
			--P_SetObjectMomZ(mo2, FRACUNIT*10, false)
            S_StartSound(mo, sfx_s1b4);
			end
            K_SpinPlayer(mo2.player, mo, 1, mo, false)
        end
    end
end    
end
addHook("MobjCollide", punchbumperCollision, MT_PLAYER)
addHook("MobjMoveCollide", punchbumperCollision, MT_PLAYER)


-- powerup lose on hit
local function manualPowHandle(victim, attacker, mo)
    if cv_powerlap.value
    if (victim.powerlap.item == plap.powitems.miniboost) or (victim.powerlap.item == plap.powitems.longboost) or (victim.powerlap.item == plap.powitems.minihyudoro)
        if victim.powerlap.inuse == true
            victim.powerlap.powtime = 0;
            victim.powerlap.item = 0;
        end
    else return end
    end
end

--addHook("PlayerSpin", manualPowHandle)
--addHook("PlayerSquish", manualPowHandle)
--addHook("PlayerExplode", manualPowHandle)


-- Bigger item effect
local itemsforbigpow = {MT_BANANA, MT_ORBINAUT, MT_ORBINAUT_SHIELD, MT_JAWZ, MT_JAWZ_SHIELD,MT_JAWZ_DUD, MT_BALLHOG, MT_EGGMANITEM, MT_EGGMANITEM_SHIELD, MT_SPB, MT_SINK}
for _,i in pairs(itemsforbigpow) do
addHook("MobjThinker", function(mobj)
    if cv_powerlap.value
        if not mobj.target return end;
        --print(mobj.target)
        if mobj.target.player.powerlap.item == plap.powitems.biggeritem and not mobj.pownobigger
            mobj.scalespeed = FRACUNIT/6
            mobj.destscale = (mapheaderinfo[gamemap].mobj_scale*2)
            if i == MT_EGGMANITEM mobj.target.player.powerlap.item = 0 end;
            if i == MT_BALLHOG mobj.fuse = TICRATE * 4 end;
            if i == MT_JAWZ_SHIELD or i == MT_ORBINAUT_SHIELD P_SetScale(mobj, (mapheaderinfo[gamemap].mobj_scale*3))end;
        elseif not mobj.pownobigger
            mobj.pownobigger = true
        end
    end
end, i)
end

-- curse attack effect
local itemsforcurseeffect = {MT_BANANA, MT_BANANA_SHIELD, MT_ORBINAUT, MT_ORBINAUT_SHIELD, MT_JAWZ, MT_JAWZ_SHIELD, MT_JAWZ_DUD, MT_BALLHOG, MT_EGGMANITEM, MT_EGGMANITEM_SHIELD, MT_SPB, MT_SSMINE, MT_SSMINE_SHIELD, MT_ROCKETSNEAKER}
for _,i in pairs(itemsforcurseeffect) do
addHook("MobjThinker", function(mobj)
    if cv_powerlap.value
        if not mobj.target return end;
        --print(mobj.target)
        if mobj.target.player.powerlap.item == plap.powitems.curseattack
            mobj.colorized = true;
            mobj.color = mobj.target.color;
            -- all astetic effect
            if leveltime%2 == 1 mobj.cursethok = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_THOK)
            mobj.cursethok.scale = mobj.scale - mapheaderinfo[gamemap].mobj_scale/8
            mobj.cursethok.frame = $ + TR_TRANS30
            mobj.cursethok.color = 93
            P_SetObjectMomZ(mobj.cursethok, FRACUNIT*5, true)
            mobj.cursethok.fuse = TICRATE/2
            end;
        else
            mobj.colorized = false;
        end
    end
end, i)
end