
local kitemsforbigpowuse = {KITEM_BANANA, KITEM_ORBINAUT, KITEM_JAWZ, KITEM_BALLHOG, KITEM_SPB, KITEM_KITCHENSINK, KITEM_GROW, KITEM_INVINCIBILITY}

-- function for checking if player can use powerup
local function CanUsePowerup(player)
    if player.kartstuff[k_itemtype]  or player.kartstuff[k_itemroulette] or player.kartstuff[k_itemheld] -- got item
         or player.kartstuff[k_spinouttimer] or player.kartstuff[k_wipeoutslow] or player.kartstuff[k_squishedtimer] -- damage state
         or player.kartstuff[k_stolentimer] or player.kartstuff[k_growshrinktimer] > 0 or player.kartstuff[k_rocketsneakertimer] -- special items
         or player.kartstuff[k_eggmanheld] or player.kartstuff[k_eggmanexplode] -- eggman related
         or player.kartstuff[k_respawn] or player.kartstuff[k_dropdash] or player.deadtimer -- respawning
         or player.powerlap.inuse == true -- already in use
         or player.powerlap.decay > 0 -- if normal item just got used
         return false; -- player cannot use it
    else
        return true; -- player can use it
    end
end

-- change the item gotten with bigger item powerup
local function Handlegrowodds(player)
    if player.kartstuff[k_itemtype] == KITEM_SNEAKER and player.kartstuff[k_itemamount] >= 2 -- triple sneakers
        local rngchange = leveltime%2 -- change the item depending witch frame is on
        if rngchange == 1 player.kartstuff[k_itemtype] = KITEM_ORBINAUT; player.kartstuff[k_itemamount] = 4
        else player.kartstuff[k_itemtype] = KITEM_JAWZ; player.kartstuff[k_itemamount] = 2
        end
    elseif player.kartstuff[k_itemtype] == KITEM_SNEAKER -- single sneaker
        local rngchange = leveltime%5
        if rngchange == 1 player.kartstuff[k_itemtype] = KITEM_BANANA; player.kartstuff[k_itemamount] = 3
        elseif rngchange == 2 player.kartstuff[k_itemtype] = KITEM_ORBINAUT; player.kartstuff[k_itemamount] = 1
        elseif rngchange == 3 player.kartstuff[k_itemtype] = KITEM_JAWZ; player.kartstuff[k_itemamount] = 1
        elseif rngchange == 4 player.kartstuff[k_itemtype] = KITEM_BALLHOG; player.kartstuff[k_itemamount] = 1
        else player.kartstuff[k_itemtype] = KITEM_EGGMAN;
        end
    elseif player.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD -- thunder shield
        local rngchange = leveltime%3
        if rngchange == 1 player.kartstuff[k_itemtype] = KITEM_BANANA; player.kartstuff[k_itemamount] = 1
        elseif rngchange == 2 player.kartstuff[k_itemtype] = KITEM_ORBINAUT; player.kartstuff[k_itemamount] = 1
        else player.kartstuff[k_itemtype] = KITEM_EGGMAN;
        end
    elseif player.kartstuff[k_itemtype] == KITEM_SHRINK -- shrink
        player.kartstuff[k_itemtype] = KITEM_GROW; player.kartstuff[k_itemamount] = 1
    end
end

-- change the item gotten with curse item powerup
local function Handlecurseodds(player)
    if player.kartstuff[k_itemtype] == KITEM_SNEAKER and player.kartstuff[k_itemamount] < 2 -- single sneaker
        local rngchange = leveltime%4
        if rngchange == 1 player.kartstuff[k_itemtype] = KITEM_ORBINAUT; player.kartstuff[k_itemamount] = 3
        elseif rngchange == 2 player.kartstuff[k_itemtype] = KITEM_BALLHOG; player.kartstuff[k_itemamount] = 1
        elseif rngchange == 3 player.kartstuff[k_itemtype] = KITEM_JAWZ; player.kartstuff[k_itemamount] = 1
        else player.kartstuff[k_itemtype] = KITEM_MINE;
        end
    elseif player.kartstuff[k_itemtype] == KITEM_SHRINK -- shrink
        player.kartstuff[k_itemtype] = KITEM_GROW; player.kartstuff[k_itemamount] = 1
    end
end

---------------------------------------------
-- main code
addHook("ThinkFrame", function()
    -- main toggle
    if cv_powerlap.value
    for player in players.iterate do
        if not (player and player.valid) continue end;
		if not (player.powerlap) continue end;      
        -- hud timer
        if player.powerlap.hudtime > 0 player.powerlap.hudtime = $ - 1 end;

        -- if somehow the player still has a powerup beetween races
        if leveltime < TICRATE * 7
            player.powerlap.item = 0;
            player.powerlap.lastlap = 0;
        end

        -- don't give poweritems if the player finished the race
        if player.exiting != 0
            player.powerlap.item = 0
            if player.powerlap.shield P_RemoveMobj(player.powerlap.shield) end;
            player.powerlap.shield = nil
            player.powerlap.rolltimer = -1
        end

        -- set default button usage
        if not (player.powerlapBTN) player.powerlapBTN = BT_ATTACK end;

        --------------------------------------------
        -- [[manual powerup check]]
        --------------------------------------------
        local Uasablepow = CanUsePowerup(player);
        if player.kartstuff[k_itemtype] != 0 or player.kartstuff[k_itemroulette] != 0 or player.kartstuff[k_itemheld] != 0 -- got item
            player.powerlap.decay = TICRATE/2
        elseif player.powerlap.decay > 0
            player.powerlap.decay = $ - 1
        end
        --print(player.powerlap.decay)
        
        if Uasablepow == false -- any condition of the function is matched
        -- do nothing, manual item can't be used
            player.powerlap.powerready = false 
        
        -- if none of condition matches, use poweritem
        elseif player.cmd.buttons & player.powerlapBTN and player.powerlap.powerready == true
            if player.powerlap.item == plap.powitems.miniboost -- mini boost
                --player.kartstuff[k_driftboost] = TICRATE * 5
                -- different timer depending the amount of laps the map has
                    if (mapheaderinfo[gamemap].numlaps <= 2) player.powerlap.powtime =  TICRATE * 10
                    elseif (mapheaderinfo[gamemap].numlaps == 3) player.powerlap.powtime =  TICRATE * 7
                    elseif (mapheaderinfo[gamemap].numlaps == 4) player.powerlap.powtime =  TICRATE * 6
                    elseif (mapheaderinfo[gamemap].numlaps >= 5) player.powerlap.powtime =  TICRATE * 5
                    else player.powerlap.powtime =  TICRATE * 5 end
                S_StartSound(player.mo, sfx_s23c)
                --player.powerlap.item = 0;
                player.powerlap.powerready = false -- turn off the button usage
                player.powerlap.inuse = true
            elseif player.powerlap.item == plap.powitems.longboost -- long boost
                --player.kartstuff[k_driftboost] = TICRATE * 10
                -- different timer depending the amount of laps the map has
                    if (mapheaderinfo[gamemap].numlaps <= 2) player.powerlap.powtime =  TICRATE * 16
                    elseif (mapheaderinfo[gamemap].numlaps == 3) player.powerlap.powtime =  TICRATE * 12
                    elseif (mapheaderinfo[gamemap].numlaps == 4) player.powerlap.powtime =  TICRATE * 10
                    elseif (mapheaderinfo[gamemap].numlaps >= 5) player.powerlap.powtime =  TICRATE * 8
                    else player.powerlap.powtime =  TICRATE * 10 end
                S_StartSound(player.mo, sfx_s23c)
                --player.powerlap.item = 0;
                player.powerlap.powerready = false
                player.powerlap.inuse = true
            elseif player.powerlap.item == plap.powitems.springdrop -- spring drop
                player.kartstuff[k_pogospring] = 1;
                K_DoPogoSpring(player.mo, 30<<FRACBITS, 2); -- jump
                player.spring = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_YELLOWSPRING) -- spawn the spring
                player.spring.fuse = TICRATE*10
                if P_IsObjectOnGround(player.mo) player.powerlap.powtime = TICRATE else player.powerlap.powtime = 1 end;
                --player.powerlap.item = 0;
                player.powerlap.powerready = false
                player.powerlap.inuse = true
            elseif player.powerlap.item == plap.powitems.minihyudoro -- mini hyudoro
                -- different timer depending the amount of laps the map has
                    if (mapheaderinfo[gamemap].numlaps <= 2) player.powerlap.powtime =  TICRATE * 10
                    elseif (mapheaderinfo[gamemap].numlaps == 3) player.powerlap.powtime =  TICRATE * 7
                    elseif (mapheaderinfo[gamemap].numlaps == 4) player.powerlap.powtime =  TICRATE * 6
                    elseif (mapheaderinfo[gamemap].numlaps >= 5) player.powerlap.powtime =  TICRATE * 5
                    else player.powerlap.powtime =  TICRATE * 5 end
                player.kartstuff[k_hyudorotimer] = $ + player.powerlap.powtime -- give the corresponding powtime and also adds to the normal hyudoro time
                S_StartSound(player.mo, sfx_s3k92)
                --player.powerlap.item = 0;
                player.powerlap.powerready = false
                player.powerlap.inuse = true
            elseif  player.powerlap.item == plap.powitems.punchbumper -- punch bumper
                 -- different timer depending the amount of laps the map has
                    if (mapheaderinfo[gamemap].numlaps <= 2) player.powerlap.powtime =  TICRATE * 12
                    elseif (mapheaderinfo[gamemap].numlaps == 3) player.powerlap.powtime =  TICRATE * 8
                    elseif (mapheaderinfo[gamemap].numlaps == 4) player.powerlap.powtime =  TICRATE * 7
                    elseif (mapheaderinfo[gamemap].numlaps >= 5) player.powerlap.powtime =  TICRATE * 5
                    else player.powerlap.powtime =  TICRATE * 4 end
                S_StartSound(player.mo, sfx_s3k41)
                for i=0,15 -- visual Effect
                    P_SpawnParaloop(player.mo.x, player.mo.y, player.mo.z + player.mo.height, FixedMul(i*FRACUNIT, player.mo.scale),
                    16, MT_NIGHTSPARKLE, i*ANGLE_22h, S_NULL, true)
                end
                player.powerlap.powerready = false
                player.powerlap.inuse = true
            elseif player.powerlap.item == plap.powitems.bananarain -- banana rain
                -- different timer depending the amount of laps the map has
                    if (mapheaderinfo[gamemap].numlaps <= 2) player.powerlap.powtime =  TICRATE * 5
                    elseif (mapheaderinfo[gamemap].numlaps == 3) player.powerlap.powtime =  TICRATE * 3
                    elseif (mapheaderinfo[gamemap].numlaps == 4) player.powerlap.powtime =  TICRATE * 2
                    elseif (mapheaderinfo[gamemap].numlaps >= 5) player.powerlap.powtime =  TICRATE * 1
                    else player.powerlap.powtime =  TICRATE * 1 end
                S_StartSound(player.mo, sfx_tossed);
                player.bananarain = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
                player.bananarain.momz = FRACUNIT * 10
                player.bananarain.destscale = mapheaderinfo[gamemap].mobj_scale * 6;
                player.bananarain.colorized = true;
                player.bananarain.color = 47;
                P_SpawnGhostMobj(player.bananarain)
                player.powerlap.powerready = false
                player.powerlap.inuse = true
            elseif player.powerlap.item == plap.powitems.growingseed -- growing seed
            -- The timer depends on how long the player holds this pow
                if player.powerlap.growtime < 300 player.kartstuff[k_growshrinktimer] = TICRATE * 4 player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*5)/4; --125%
                elseif player.powerlap.growtime < 600 player.kartstuff[k_growshrinktimer] = TICRATE * 5 player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*3)/2; --150%
                elseif player.powerlap.growtime < 1000 player.kartstuff[k_growshrinktimer] = TICRATE * 6 player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*7)/4; --175%
                elseif player.powerlap.growtime >= 1000 player.kartstuff[k_growshrinktimer] = TICRATE * 8 player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*2)-100;--199%
                else player.kartstuff[k_growshrinktimer] = TICRATE * 4 player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*5)/4 end; --125%
                --player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*3)/2;
                K_PlayPowerGloatSound(player.mo);
                -- empty those values
                player.powerlap.item = 0;
                player.powerlap.growtime = 0;
            end

        -- already pressed, avoid triggering after using an item
        elseif player.cmd.buttons & player.powerlapBTN 
            
            player.powerlap.powerready = false -- turn off the button usage

        -- restore button usage
        else 
            player.powerlap.powerready = true
        end


        ---- MANUAL IN USE ----
        if (player.powerlap.item == plap.powitems.miniboost or player.powerlap.item == plap.powitems.longboost) and player.powerlap.powtime > 1
            player.kartstuff[k_driftboost] = 2
            -- boost bonus for long boost
            if (player.powerlap.item == plap.powitems.longboost and player.kartstuff[k_sneakertimer] > 1) player.kartstuff[k_boostpower] = FRACUNIT + FRACUNIT/5 end
        elseif player.powerlap.item == plap.powitems.minihyudoro and player.powerlap.powtime > 1
            if not player.kartstuff[k_hyudorotimer] player.kartstuff[k_hyudorotimer] = player.powerlap.powtime end
        elseif player.powerlap.item == plap.powitems.springdrop and player.powerlap.powtime > 1 and player.powerlap.powtime < 34
            player.mo.momz = 0
            player.kartstuff[k_pogospring] = 1;
        elseif player.powerlap.item == plap.powitems.bananarain and player.powerlap.powtime > 1
             -- cycle spawn
             if leveltime%35 == 1 player.bananarain = P_SpawnMobj(player.mo.x+FRACUNIT*200, player.mo.y+FRACUNIT*200, player.mo.z+FRACUNIT*250, MT_BANANA)
            elseif leveltime%35 == 10 player.bananarain = P_SpawnMobj(player.mo.x-FRACUNIT*200, player.mo.y+FRACUNIT*100, player.mo.z+FRACUNIT*250, MT_BANANA)
            elseif leveltime%35 == 19 player.bananarain = P_SpawnMobj(player.mo.x+FRACUNIT, player.mo.y-FRACUNIT*300, player.mo.z+FRACUNIT*250, MT_BANANA)
            elseif leveltime%35 == 28 player.bananarain = P_SpawnMobj(player.mo.x-FRACUNIT*100, player.mo.y-FRACUNIT*100, player.mo.z+FRACUNIT*250, MT_BANANA)
            end

            if (player.bananarain)
             player.bananarain.momz = FRACUNIT*2;
             player.bananarain.target = player.mo;
             player.bananarain.scale = 1;
             player.bananarain.destscale = mapheaderinfo[gamemap].mobj_scale;
            end
        end
        -- punch bumper
        if player.powerlap.item == plap.powitems.punchbumper
            if player.powerlap.inuse == true
                --player.powerlap.inuse = true;
                if player.kartstuff[k_offroad] == 0 player.kartstuff[k_boostpower] = FRACUNIT + FRACUNIT/6 end
                player.kartstuff[k_accelboost] = $ + FRACUNIT*3/4
                -- visual tweaks
                if not player.kartstuff[k_hyudorotimer] -- players should not see the ghost
                    player.mo.colorized = true
                    K_SpawnSparkleTrail(player.mo)
                end
            end
            -- freeze timer during some conditions
            if player.kartstuff[k_hyudorotimer] != 0 or player.powers[pw_flashing] != 0 -- flashtics
             or player.kartstuff[k_growshrinktimer] > 0 or player.kartstuff[k_invincibilitytimer] != 0 --invincibilty
             or player.kartstuff[k_respawn] > 1 -- dying
                player.powerlap.powtime = $ + 1
            end
        end



        -- freeze manual powerup timer
        if player.powerlap.item == plap.powitems.minihyudoro or player.powerlap.item == plap.powitems.miniboost or player.powerlap.item == plap.powitems.longboost
            if player.powerlap.inuse == true
            if (player.kartstuff[k_respawn] != 0 or player.kartstuff[k_dropdash] != 0 or player.deadtimer != 0)
                player.powerlap.powtime = $ + 1
            elseif player.kartstuff[k_invincibilitytimer] > 0 and (player.powerlap.item == plap.powitems.miniboost or player.powerlap.item == plap.powitems.longboost)
                if leveltime % 4 != 1 player.powerlap.powtime = $ + 1 end
            end
            end
        end

        -- timer for growing seed
        if player.powerlap.item == plap.powitems.growingseed
            if (mapheaderinfo[gamemap].numlaps <= 2 and player.powerlap.growtime == 0) player.powerlap.growtime = 200 end; -- give bonus for 2 lappers
            local distgrowseed = R_PointToDist2(player.mo.x,player.mo.y,plap.first.x,plap.first.y)/FRACUNIT; -- calculates distance
            --print(player.powerlap.growtime)
            -- charge until it reachs "100%"
            if player.powerlap.growtime < 1000
                if player.kartstuff[k_position] == 1 -- 1st place -0.25 per frame
                    if leveltime%4 == 1 and player.powerlap.growtime > 0 player.powerlap.growtime = $ - 1 end;
                elseif distgrowseed < 1500 -- +0 if close to 1st
                    player.powerlap.growtime = $
                elseif distgrowseed < 4000 -- +0.3 per frame aka 25 sec for 1 lvl
                    if leveltime%3 == 1 player.powerlap.growtime = $ + 1 end;
                elseif distgrowseed < 8500 -- +0.5 per frame aka 17 sec for 1 lvl
                    if leveltime%2 == 1 player.powerlap.growtime = $ + 1 end;
                elseif distgrowseed < 13000 -- +1 per frame aka 9 sec for 1 lvl
                    player.powerlap.growtime = $ + 1
                else -- max dist +1.5 per frame aka 6 sec for 1 lvl
                    player.powerlap.growtime = $ + 1
                    if leveltime%2 == 1 player.powerlap.growtime = $ + 1 end;
                end
            end
            --player.powerlap.powtime = $ + 1;
        else
            player.powerlap.growtime = 0;
        end



        
        -------------------------------------
        -- [[Automatic powerups]]
        -- protect shield
        if player.powerlap.item == plap.powitems.protectshield
            player.powerlap.powtime = 1
            if not (player.MTshield) player.MTshield = MT_BLUEORB end;
            if player.powerlap.shield == nil
                --print("sheild")
                player.powers[pw_shield] = SH_PITY
                player.powerlap.shield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, player.MTshield);
                --S_StartSound(player.mo, sfx_shield)
            end
            
            if player.playerstate == 1 -- respawning
             or (player.kartstuff[k_invincibilitytimer] > 0 and player.playerstate == 0)
                player.powers[pw_shield] = SH_NONE
                if player.powerlap.shield.valid
                 --print(player.powerlap.toptier.totalframes);
                 --player.powerlap.shield.flags2 = MF2_DONTDRAW
                 P_RemoveMobj(player.powerlap.shield) 
                 player.powerlap.shield = nil;
                end;
            elseif player.kartstuff[k_respawn] == 2 -- restore shield
                player.powers[pw_shield] = SH_PITY
                --P_SpawnShieldOrb(player)
                player.powerlap.shield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, player.MTshield);
                S_StartSound(player.mo, sfx_shield)
                --print("aaaaaaaa");
            else
                player.powers[pw_shield] = SH_PITY
            end
        else
            player.powerlap.shield = nil;
            player.powers[pw_shield] = SH_NONE
        end


        -- bigger item
        if player.powerlap.item == plap.powitems.biggeritem
            player.powerlap.powtime = 1
            if player.powerlap.inuse == true and player.kartstuff[k_itemtype] == 0 and player.kartstuff[k_roulettetype] != 2 -- powerup used
                player.powerlap.item = 0;
                player.powerlap.inuse = false;
            end
            for _,i in pairs(kitemsforbigpowuse) do -- show if the item can be bigger
                if player.powerlap.inuse == false and player.kartstuff[k_itemtype] == i
                    if (i == KITEM_GROW and player.kartstuff[k_growshrinktimer] > 0) break end;
                    player.powerlap.inuse = true;
                    break;
                end
            end
            if player.kartstuff[k_roulettetype] == 2 -- don't lose the powerup if he took an eggbox
                player.powerlap.inuse = false;
            end
            if player.kartstuff[k_growshrinktimer] > TICRATE * 11 -- grow timer is 12 tics, so getting the powerup in the middle of grow won't increase the size suddenly
                player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*2)-100 -- (199%)
                player.powerlap.item = 0; -- use the powerup if player used the item right before getting this powerup
                -- consider this is a good usage of the powerup even if it's accidental
            end
            if player.kartstuff[k_invincibilitytimer] > TICRATE * 9 -- give grow on invincibility, and same thing from above
                player.kartstuff[k_growshrinktimer] = player.kartstuff[k_invincibilitytimer]
                player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*5)/4 -- (125%)
                player.powerlap.item = 0;
            end

            -- specefic items replacement
            if player.kartstuff[k_itemblink] == TICRATE and
             (player.kartstuff[k_itemtype] == KITEM_SNEAKER or player.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD or player.kartstuff[k_itemtype] == KITEM_SHRINK)
                Handlegrowodds(player)
            end
        end

        -- double amount
        if player.powerlap.item == plap.powitems.doubleamount
            player.powerlap.powtime = 1
            if player.kartstuff[k_itemroulette] > 0 player.powerlap.inuse = true end; -- make blink
            if player.kartstuff[k_itemtype] != 0 and player.kartstuff[k_itemtype] != KITEM_HYUDORO and player.kartstuff[k_itemtype] != KITEM_SHRINK and player.powerlap.inuse == true
                player.kartstuff[k_itemamount] = $ * 2
                player.powerlap.item = 0
            end
            if player.kartstuff[k_itemtype] == 0 and player.kartstuff[k_itemroulette] == 0 player.powerlap.inuse = false end;
        end

        if player.powerlap.item == plap.powitems.curseattack
            if player.powerlap.inuse == false player.powerlap.powtime = 1 end
        end

        -- curse attack
        if player.powerlap.item == plap.powitems.curseattack
            if player.kartstuff[k_itemblink] == TICRATE and
            (player.kartstuff[k_itemtype] == KITEM_SNEAKER or player.kartstuff[k_itemtype] == KITEM_SHRINK)
                Handlecurseodds(player)
            end
        end

        --
        -- Droppable auto powerups
        --
        if not (player.kartstuff[k_itemtype] != 0 or player.kartstuff[k_itemroulette] != 0 or player.kartstuff[k_itemheld] != 0 -- got item
         or player.kartstuff[k_stolentimer] != 0 or player.kartstuff[k_growshrinktimer] > 0 or player.kartstuff[k_rocketsneakertimer] -- special items
         or player.kartstuff[k_eggmanheld] != 0 or player.kartstuff[k_eggmanexplode] != 0 -- eggman related
         or player.powerlap.inuse == true or player.kartstuff[k_position] == 1)
            if player.powerlap.item == plap.powitems.protectshield or player.powerlap.item == plap.powitems.biggeritem or player.powerlap.item == plap.powitems.doubleamount or player.powerlap.item == plap.powitems.curseattack
             if player.cmd.buttons & player.powerlapBTN
                if leveltime%2 == 1 player.powerlap.discardtime = $ + 1 end;
             else
                player.powerlap.discardtime = 0
             end
            end

        else
            player.powerlap.discardtime = 0
        end
        if player.powerlap.discardtime >= 24 -- on discard
            player.powerlap.item = 0;
            player.powerlap.inuse = false;
            if player.powerlap.shield P_RemoveMobj(player.powerlap.shield); end -- remove shield
            player.powerlap.shield = nil;
            -- give an item instead
            player.kartstuff[k_itemtype] = KITEM_SNEAKER;
            player.kartstuff[k_itemamount] = 1;
        end


        -------------------------------------
        -- [[Instant powerups]]
        -- faster spark
        if player.powerlap.item == plap.powitems.fasterspark
            -- trigger the powerup as soon the player gets it
            if not (player.powerlap.inuse) 
                player.powerlap.inuse = true
                -- different timer depending the amount of laps the map has
                    if (mapheaderinfo[gamemap].numlaps <= 2) player.powerlap.powtime =  TICRATE * 20
                    elseif (mapheaderinfo[gamemap].numlaps == 3) player.powerlap.powtime =  TICRATE * 15
                    elseif (mapheaderinfo[gamemap].numlaps == 4) player.powerlap.powtime =  TICRATE * 12
                    elseif (mapheaderinfo[gamemap].numlaps >= 5) player.powerlap.powtime =  TICRATE * 10
                    else player.powerlap.powtime =  TICRATE * 10 end
            -- effect during the powtime
            else
                if P_IsObjectOnGround(player.mo) player.kartstuff[k_driftcharge] = $ + 20 end 
                if player.kartstuff[k_respawn] > 1 or player.deadtimer != 0 player.powerlap.powtime = $ + 1 end; -- freeze timer on respawn
                if player.kartstuff[k_invincibilitytimer] > 0 and leveltime%4 != 1 player.powerlap.powtime = $ + 1 end; -- slow down timer on invinc
            end;
        end


        -- super mode
        if player.powerlap.item == plap.powitems.supermode and player.kartstuff[k_spinouttimer] == 0 and player.kartstuff[k_wipeoutslow] == 0 and player.kartstuff[k_squishedtimer] == 0
            -- trigger the powerup as soon the player gets it
            if not (player.powerlap.inuse)
                player.powerlap.inuse = true;
                if not (player.supercolor) player.supercolor = {i = 1, j = 1, picked = 101} end;
                -- different timer depending the amount of laps the map has
                    if (mapheaderinfo[gamemap].numlaps <= 2) player.powerlap.powtime =  TICRATE * 16
                    elseif (mapheaderinfo[gamemap].numlaps == 3) player.powerlap.powtime =  TICRATE * 15
                    elseif (mapheaderinfo[gamemap].numlaps == 4) player.powerlap.powtime =  TICRATE * 12
                    elseif (mapheaderinfo[gamemap].numlaps >= 5) player.powerlap.powtime =  TICRATE * 10
                    else player.powerlap.powtime =  TICRATE * 10 end
                player.supercolor.i = 1; player.supercolor.j = 1;
                if player.kartstuff[k_growshrinktimer] > 0 player.kartstuff[k_growshrinktimer] = 1 end;
                S_StartSound(player.mo, sfx_supert) -- sound effect
-- TODO: add music
            else -- effect during the powtime
                player.kartstuff[k_invincibilitytimer] = 2
                player.kartstuff[k_accelboost] = FRACUNIT*8
                if (player.kartstuff[k_sneakertimer] > 1) player.kartstuff[k_speedboost] = -FRACUNIT/2 + FRACUNIT -- if a boostpad/sneaker is used
                else player.kartstuff[k_speedboost] = -FRACUNIT/4 + FRACUNIT/2; player.kartstuff[k_sneakertimer] = 1 end; -- give boost and sliptide

                -- some item nerfs
                if player.kartstuff[k_itemtype] == KITEM_ROCKETSNEAKER 
                 player.kartstuff[k_itemtype] = KITEM_SNEAKER
                elseif player.kartstuff[k_itemtype] == KITEM_INVINCIBILITY or player.kartstuff[k_itemtype] == KITEM_GROW or player.kartstuff[k_itemtype] == KITEM_HYUDORO
                 player.kartstuff[k_itemtype] = KITEM_SNEAKER
                 player.kartstuff[k_itemamount] = 2
                end;

                -- color effect
                if leveltime%4 == 1
                    player.supercolor.i = $ + player.supercolor.j
			        if player.supercolor.i >= 4 player.supercolor.j = -1 end
			        if player.supercolor.i <= 0 player.supercolor.j = 1 end
		        end
                player.mo.color = player.supercolor.picked + player.supercolor.i;
                player.mo.colorized = false -- make sure color cycle works
                local ghost = P_SpawnGhostMobj(player.mo)
                ghost.frame = $ + FF_FULLBRIGHT

                -- during death animation, freeze the powerup timer
                if player.deadtimer != 0 player.powerlap.powtime = $ + 1 end;
            end
        end


  

        -- item recollect
        if player.powerlap.item == plap.powitems.itemrecollect
		
            if not player.powerlap.inuse
                player.powerlap.inuse = true;
				
                -- different timer depending the amount of laps the map has
                if (mapheaderinfo[gamemap].numlaps <= 2) player.powerlap.powtime =  TICRATE * 20
                elseif (mapheaderinfo[gamemap].numlaps == 3) player.powerlap.powtime =  TICRATE * 15
                elseif (mapheaderinfo[gamemap].numlaps == 4) player.powerlap.powtime =  TICRATE * 12
                elseif (mapheaderinfo[gamemap].numlaps >= 5) player.powerlap.powtime =  TICRATE * 10
                else player.powerlap.powtime =  TICRATE * 10 end
            else
                if player.powerlap.powtime == 1
                    if player.kartstuff[k_itemtype] != 0 or player.kartstuff[k_itemroulette] != 0 or player.kartstuff[k_itemheld] != 0 -- got item
                     or player.kartstuff[k_eggmanheld] != 0 or player.kartstuff[k_eggmanexplode] != 0 -- eggman related
                     or player.kartstuff[k_growshrinktimer] > 0 -- also don't give item during grow
                     or player.kartstuff[k_spinouttimer] != 0 or player.kartstuff[k_wipeoutslow] != 0 or player.kartstuff[k_squishedtimer] != 0 -- damage state
                        -- freeze timer until player uses his item
                        player.powerlap.powtime = $ + 1
                        
                    elseif player.powerlap.collectitem == nil
                        player.powerlap.collectitem = KITEM_SNEAKER
                    end
                end
            end
        end
        -- handle the item we get from item recollect
        if player.powerlap.collectitem != nil and player.powerlap.powtime == 0
            player.kartstuff[k_itemtype] = player.powerlap.collectitem
            -- item amount
            if player.powerlap.collectitem == KITEM_SNEAKER --
                if (mapheaderinfo[gamemap].numlaps <= 2) player.kartstuff[k_itemamount] = 2
                else player.kartstuff[k_itemamount] = 1 end
            elseif player.powerlap.collectitem == KITEM_BANANA --
                if (mapheaderinfo[gamemap].numlaps <= 2) player.kartstuff[k_itemamount] = $ + 8
                elseif (mapheaderinfo[gamemap].numlaps == 3) player.kartstuff[k_itemamount] = $ + 5
                elseif (mapheaderinfo[gamemap].numlaps >= 4) player.kartstuff[k_itemamount] = $ + 3 end
            elseif player.powerlap.collectitem == KITEM_ORBINAUT --
                if (mapheaderinfo[gamemap].numlaps <= 2) player.kartstuff[k_itemamount] = $ + 5
                elseif (mapheaderinfo[gamemap].numlaps == 3) player.kartstuff[k_itemamount] = $ + 3
                elseif (mapheaderinfo[gamemap].numlaps >= 4) player.kartstuff[k_itemamount] = $ + 2 end
            elseif player.powerlap.collectitem == KITEM_JAWZ --
                if (mapheaderinfo[gamemap].numlaps <= 2) player.kartstuff[k_itemamount] = $ + 3
                elseif (mapheaderinfo[gamemap].numlaps == 3) player.kartstuff[k_itemamount] = $ + 2
                elseif (mapheaderinfo[gamemap].numlaps >= 4) player.kartstuff[k_itemamount] = $ + 1 end
            elseif player.powerlap.collectitem == KITEM_BALLHOG --
                if (mapheaderinfo[gamemap].numlaps <= 2) player.kartstuff[k_itemamount] = $ + 3
                elseif (mapheaderinfo[gamemap].numlaps == 3) player.kartstuff[k_itemamount] = $ + 2
                elseif (mapheaderinfo[gamemap].numlaps >= 4) player.kartstuff[k_itemamount] = $ + 1 end
            elseif player.powerlap.collectitem == KITEM_EGGMAN --
                if (mapheaderinfo[gamemap].numlaps <= 2) player.kartstuff[k_itemamount] = $ + 3
                elseif (mapheaderinfo[gamemap].numlaps == 3) player.kartstuff[k_itemamount] = $ + 2
                elseif (mapheaderinfo[gamemap].numlaps >= 4) player.kartstuff[k_itemamount] = $ + 1 end
            elseif player.powerlap.collectitem == KITEM_MINE --
                if (mapheaderinfo[gamemap].numlaps <= 2) player.kartstuff[k_itemamount] = $ + 2
                else player.kartstuff[k_itemamount] = $ + 1 end
            elseif player.powerlap.collectitem == KITEM_INVINCIBILITY
                if (mapheaderinfo[gamemap].numlaps <= 2) player.kartstuff[k_invincibilitytimer] = $ + TICRATE * 6
                elseif (mapheaderinfo[gamemap].numlaps == 3) player.kartstuff[k_invincibilitytimer] = $ + TICRATE * 4
                elseif (mapheaderinfo[gamemap].numlaps >= 4) player.kartstuff[k_invincibilitytimer] = $ + TICRATE * 3 end
            elseif player.powerlap.collectitem == KITEM_GROW  
                if (mapheaderinfo[gamemap].numlaps <= 2) player.kartstuff[k_growshrinktimer] = TICRATE * 6;
                elseif (mapheaderinfo[gamemap].numlaps == 3) player.kartstuff[k_growshrinktimer] = TICRATE * 4;
                elseif (mapheaderinfo[gamemap].numlaps >= 4) player.kartstuff[k_growshrinktimer] = TICRATE * 3; end
                player.mo.destscale = (mapheaderinfo[gamemap].mobj_scale*3)/2
            elseif player.powerlap.collectitem == KITEM_THUNDERSHIELD player.kartstuff[k_itemamount] = 1
            end
            player.kartstuff[k_itemblinkmode] = 0
            player.kartstuff[k_itemblink] = TICRATE
            -- make sure it doesn't repeat
            player.powerlap.collectitem = nil
        end


        -------------------------------------
        -- general powerup timer fuse
        if (player.powerlap.powtime >= 0 and player.powerlap.inuse == true) player.powerlap.powtime = $ - 1 end; -- decrement in use
        -- some timers goes twice as fast if player is 1st
        if player.kartstuff[k_position] == 1 and player.powerlap.inuse == true and not (player.kartstuff[k_respawn] != 0 or player.kartstuff[k_dropdash] != 0 or player.deadtimer != 0) and
        (player.powerlap.item == plap.powitems.miniboost or
        player.powerlap.item == plap.powitems.longboost or
        player.powerlap.item == plap.powitems.supermode)
        player.powerlap.powtime = $ - 1
        end

        if (player.powerlap.powtime < 0 and player.powerlap.item != 0) player.powerlap.item = 0; player.powerlap.powtime = 1 end; -- powtime is timeout
        -- reset inuse state
        if (player.powerlap.item == 0) player.powerlap.inuse = false; player.powerlap.powtime = 1 end;
    end
    

    -------------------------------------------
    -- powerlap is OFF
    else
        for player in players.iterate do
        if not (player and player.valid) continue end;
		if not (player.powerlap) continue end;
        player.powers[pw_shield] = SH_NONE
        player.powerlap.item = 0;
        player.powerlap.inuse = false;
        player.powerlap.powtime = 1;
        player.powerlap.discardtime = 0
        player.powerlap.rolltimer = -1
        if player.powerlap.shield P_RemoveMobj(player.powerlap.shield) end;
        player.powerlap.shield = nil;
        end
    end
end)

