-- function for init or resetting powerup vars to players
local function resetpowvars(player)
    player.powerlap = {
        powerready = false, -- button check
        lastlap = 0, -- lap update
        item = 0, -- powerup player has
        shield = nil, -- shield mobj check
        --MTshield = $.MTshield, -- shield picked
        --supercolor = {i = 1, j = 1, picked = $.supercolor.picked}, -- super mode color
        rolltimer = -1, -- roll timer
        hudtime = 0, -- hud stuff
        powtime = 0, -- timer for stuff
        growtime = 0, -- timer for grow seed
        decay = 0, -- decay for using manual pow
        discardtime = 0, -- timer for discard auto pows
        firstplace = {x = nil, y = nil}, -- player distance
        inuse = false, -- powerup is in use
        hasspbitem = false, -- spb check for bonus
        --button = $,

    -- top half items
    -- higher is the amount of frames, higher is the chance of getting this powerup
    toptier_L = {{id = plap.powitems.miniboost, frames = 10}, {id = plap.powitems.longboost, frames = 0},
        {id = plap.powitems.springdrop, frames = 0}, {id = plap.powitems.protectshield, frames = 8}, {id = plap.powitems.minihyudoro, frames = 0},
        {id = plap.powitems.biggeritem, frames = 4}, {id = plap.powitems.doubleamount, frames = 2}, {id = plap.powitems.fasterspark, frames = 4},
        {id = plap.powitems.supermode, frames = 0}, {id = plap.powitems.punchbumper, frames = 6}, {id = plap.powitems.bananarain, frames = 6},
        {id = plap.powitems.itemrecollect, frames = 2}, {id = plap.powitems.growingseed, frames = 0}, {id = plap.powitems.curseattack, frames = 6},
                totalframes = 0},
    toptier_M = {{id = plap.powitems.miniboost, frames = 8}, {id = plap.powitems.longboost, frames = 2},
        {id = plap.powitems.springdrop, frames = 2}, {id = plap.powitems.protectshield, frames = 4}, {id = plap.powitems.minihyudoro, frames = 4},
        {id = plap.powitems.biggeritem, frames = 0}, {id = plap.powitems.doubleamount, frames = 0}, {id = plap.powitems.fasterspark, frames = 6},
        {id = plap.powitems.supermode, frames = 0}, {id = plap.powitems.punchbumper, frames = 4}, {id = plap.powitems.bananarain, frames = 4},
        {id = plap.powitems.itemrecollect, frames = 6}, {id = plap.powitems.growingseed, frames = 0}, {id = plap.powitems.curseattack, frames = 4},
                totalframes = 0},
    toptier_H = {{id = plap.powitems.miniboost, frames = 0}, {id = plap.powitems.longboost, frames = 8},
        {id = plap.powitems.springdrop, frames = 4}, {id = plap.powitems.protectshield, frames = 0}, {id = plap.powitems.minihyudoro, frames = 0},
        {id = plap.powitems.biggeritem, frames = 4}, {id = plap.powitems.doubleamount, frames = 4}, {id = plap.powitems.fasterspark, frames = 4},
        {id = plap.powitems.supermode, frames = 1}, {id = plap.powitems.punchbumper, frames = 0}, {id = plap.powitems.bananarain, frames = 0},
        {id = plap.powitems.itemrecollect, frames = 0}, {id = plap.powitems.growingseed, frames = 4}, {id = plap.powitems.curseattack, frames = 0},
                totalframes = 0},

    -- bottom half items
    bottomtier_L = {{id = plap.powitems.miniboost, frames = 6}, {id = plap.powitems.longboost, frames = 0},
        {id = plap.powitems.springdrop, frames = 0}, {id = plap.powitems.protectshield, frames = 4}, {id = plap.powitems.minihyudoro, frames = 4},
        {id = plap.powitems.biggeritem, frames = 4}, {id = plap.powitems.doubleamount, frames = 2}, {id = plap.powitems.fasterspark, frames = 6},
        {id = plap.powitems.supermode, frames = 0}, {id = plap.powitems.punchbumper, frames = 6}, {id = plap.powitems.bananarain, frames = 0},
        {id = plap.powitems.itemrecollect, frames = 4}, {id = plap.powitems.growingseed, frames = 0}, {id = plap.powitems.curseattack, frames = 4},
                totalframes = 0},
    bottomtier_M = {{id = plap.powitems.miniboost, frames = 2}, {id = plap.powitems.longboost, frames = 6},
        {id = plap.powitems.springdrop, frames = 4}, {id = plap.powitems.protectshield, frames = 0}, {id = plap.powitems.minihyudoro, frames = 4},
        {id = plap.powitems.biggeritem, frames = 0}, {id = plap.powitems.doubleamount, frames = 2}, {id = plap.powitems.fasterspark, frames = 4},
        {id = plap.powitems.supermode, frames = 1}, {id = plap.powitems.punchbumper, frames = 0}, {id = plap.powitems.bananarain, frames = 0},
        {id = plap.powitems.itemrecollect, frames = 0}, {id = plap.powitems.growingseed, frames = 4}, {id = plap.powitems.curseattack, frames = 0},
                totalframes = 0},
    bottomtier_H = {{id = plap.powitems.miniboost, frames = 0}, {id = plap.powitems.longboost, frames = 10},
        {id = plap.powitems.springdrop, frames = 0}, {id = plap.powitems.protectshield, frames = 0}, {id = plap.powitems.minihyudoro, frames = 0},
        {id = plap.powitems.biggeritem, frames = 6}, {id = plap.powitems.doubleamount, frames = 6}, {id = plap.powitems.fasterspark, frames = 0},
        {id = plap.powitems.supermode, frames = 2}, {id = plap.powitems.punchbumper, frames = 0}, {id = plap.powitems.bananarain, frames = 0},
        {id = plap.powitems.itemrecollect, frames = 0}, {id = plap.powitems.growingseed, frames = 6}, {id = plap.powitems.curseattack, frames = 0},
                totalframes = 0},

    -- first place items (if turned on)
    firsttier = {{id = plap.powitems.miniboost, frames = 6}, {id = plap.powitems.longboost, frames = 0},
        {id = plap.powitems.springdrop, frames = 0}, {id = plap.powitems.protectshield, frames = 4}, {id = plap.powitems.minihyudoro, frames = 0},
        {id = plap.powitems.biggeritem, frames = 0}, {id = plap.powitems.doubleamount, frames = 1}, {id = plap.powitems.fasterspark, frames = 2},
        {id = plap.powitems.supermode, frames = 0}, {id = plap.powitems.punchbumper, frames = 0}, {id = plap.powitems.bananarain, frames = 0},
        {id = plap.powitems.itemrecollect, frames = 0}, {id = plap.powitems.growingseed, frames = 0}, {id = plap.powitems.curseattack, frames = 6},
            totalframes = 0},
    }

    -- apply items frames on totalframes
    for key,i in ipairs(player.powerlap.toptier_L) do
        if plap.powtoggle[key] == false continue end; -- do not include the frames of pow toggled off
        player.powerlap.toptier_L.totalframes = $ + i.frames;
    end
    player.powerlap.toptier_L.totalframes = $ + 2;  -- additional frame for getting nothing
    for key,i in ipairs(player.powerlap.toptier_M) do
        if plap.powtoggle[key] == false continue end;
        player.powerlap.toptier_M.totalframes = $ + i.frames;
    end
    for key,i in ipairs(player.powerlap.toptier_H) do
        if plap.powtoggle[key] == false continue end;
        player.powerlap.toptier_H.totalframes = $ + i.frames;
    end
    for key,i in ipairs(player.powerlap.bottomtier_L) do
        if plap.powtoggle[key] == false continue end;
        player.powerlap.bottomtier_L.totalframes = $ + i.frames;
    end
    for key,i in ipairs(player.powerlap.bottomtier_M) do
        if plap.powtoggle[key] == false continue end;
        player.powerlap.bottomtier_M.totalframes = $ + i.frames;
    end
    for key,i in ipairs(player.powerlap.bottomtier_H) do
        if plap.powtoggle[key] == false continue end;
        player.powerlap.bottomtier_H.totalframes = $ + i.frames;
    end
    -- this is for adding powerups for the player in first
    -- will execute if the cvar is turned on
    if cv_powerlap_powforfirst.value
        for key,i in ipairs(player.powerlap.firsttier) do
            if plap.powtoggle[key] == false continue end;
            player.powerlap.firsttier.totalframes = $ + i.frames;
        end
        player.powerlap.firsttier.totalframes = $ + 4;  -- + 4 frames of nothing
    end

end

-- Netvar
addHook("NetVars", function(net)
    plap = net($)
    powerlap = net($)
end)

-- map change
addHook("MapChange", function(themap) -- this function doesn't run on player join for some reason
    if cv_powerlap.value -- main toggle
    
    -- reset plap vars
    -- apply/reset powerlap values
        for player in players.iterate do
            if not (player and player.valid) continue end;
            resetpowvars(player) -- reset players vars
            player.powers[pw_shield] = SH_NONE
            player.bananarain = nil;        
        end
    end
end)


addHook("ThinkFrame", function()
    if cv_powerlap.value
    for player in players.iterate do
        -- should sync players
        if not (player and player.valid) continue end;
        if player.spectator continue end;
        --if not (player.powerlap) continue end;
        if not player.powerlap resetpowvars(player) end;
        

        -- update first place position for distribution rng
        --plap.first = {x = player.powerlap.firstplace.x, y = player.powerlap.firstplace.y};
        if player.kartstuff[k_position] == 1 plap.first.x = player.mo.x; plap.first.y = player.mo.y end;
        local distance = R_PointToDist2(player.mo.x,player.mo.y,plap.first.x,plap.first.y)/FRACUNIT; -- calculates distance

        -- No powerup
        if player.powerlap.item == 99
            player.powerlap.inuse = true
        end

        ------------------------------------------
        -- If powonstart cver is on
        if cv_powerlap_powonstart.value
            if leveltime == TICRATE * 8 player.powerlap.rolltimer = TICRATE + #player + gamemap%4 end
        end

        -------------------------------------------
        -- spb gives powerup
        if player.powerlap.hasspbitem == true
            if player.cmd.buttons & BT_ATTACK and player.playerstate == 0 and player.kartstuff[k_respawn] == 0
                if player.powerlap.item == 0 player.powerlap.rolltimer = TICRATE
                elseif player.kartstuff[k_itemamount] < 1 player.kartstuff[k_itemroulette] = TICRATE -- player already has a powerup
                end
            end
        end

        -- check if player can use spb
        if not (player.cmd.buttons & BT_ATTACK) and player.kartstuff[k_itemtype] == KITEM_SPB and player.playerstate == 0 and player.kartstuff[k_respawn] == 0
         and player.kartstuff[k_spinouttimer] == 0 and player.kartstuff[k_wipeoutslow] == 0 and player.kartstuff[k_squishedtimer] == 0 -- damage state
            player.powerlap.hasspbitem = true
        else player.powerlap.hasspbitem = false
        end
        --print(player.playerstate)

        -------------------------------------------
        -- powerup roll
        if player.powerlap.rolltimer > 0 and player.playerstate == 0 and player.kartstuff[k_respawn] == 0 -- freeze during respawn
            player.powerlap.rolltimer = $ - 1 -- decrement
            if leveltime%2 == 1 plap.randompatch = P_RandomKey(#plap.powpatchs) end;

            -- [[sound effect]]
            if player.powerlap.rolltimer%3 == 1
                S_StartSound(nil, sfx_itrol1 + ((player.powerlap.rolltimer / 3) % 8), player);
            end

            --print(plap.randompatch + 1)
        -- give item
        elseif player.powerlap.rolltimer == 0
            
            player.powerlap.rolltimer = $ - 1 -- avoid repeat

            S_StartSound(nil, sfx_itrolf, player) -- play sound
            
            --print("frame: " + actualFrame)
            
            -- item distribution
            if player.kartstuff[k_position] == 1
                if player.powerlap.firsttier.totalframes > 0 -- not throwing an error if the cvar is off
                    local actualFrame = leveltime%player.powerlap.firsttier.totalframes; -- take a number based on the amount of frames of the tier
                    -- check if the poweritem frame is higher than the actualFrame
                    -- if so, give the player the corresponding powerup
                    for _,i in ipairs(player.powerlap.firsttier) do
                        if plap.powtoggle[i.id] == false continue end; -- don't add the pow if it's turned off
                        if i.frames > actualFrame
                            player.powerlap.item = i.id; -- get powerup
                            break;
                        else
                            actualFrame = $ - i.frames; -- reduce the amount of frames for the next powerup
                        end
                    end
                end
            elseif K_IsPlayerLosing(player) == false -- tophalf
                if distance <= 4000
                    local actualFrame = leveltime%player.powerlap.toptier_L.totalframes; -- take a number based on the amount of frames of the tier
                    -- check if the poweritem frame is higher than the actualFrame
                    -- if so, give the player the corresponding powerup
                    for _,i in ipairs(player.powerlap.toptier_L) do
                        if plap.powtoggle[i.id] == false continue end;
                        if i.frames > actualFrame
                            player.powerlap.item = i.id; -- get powerup
                            break;
                        else
                            actualFrame = $ - i.frames; -- reduce the amount of frames for the next powerup
                        end
                    end
                elseif distance >= 4000 and distance <= 8000
                    local actualFrame = leveltime%player.powerlap.toptier_M.totalframes; -- take a number based on the amount of frames of the tier
                    -- check if the poweritem frame is higher than the actualFrame
                    -- if so, give the player the corresponding powerup
                    for _,i in ipairs(player.powerlap.toptier_M) do
                        if plap.powtoggle[i.id] == false continue end;
                        if i.frames > actualFrame
                            player.powerlap.item = i.id; -- get powerup
                            break;
                        else
                            actualFrame = $ - i.frames; -- reduce the amount of frames for the next powerup
                        end
                    end
                else
                    local actualFrame = leveltime%player.powerlap.toptier_H.totalframes; -- take a number based on the amount of frames of the tier
                    -- check if the poweritem frame is higher than the actualFrame
                    -- if so, give the player the corresponding powerup
                    for _,i in ipairs(player.powerlap.toptier_H) do
                        if plap.powtoggle[i.id] == false continue end;
                        if i.frames > actualFrame
                            player.powerlap.item = i.id; -- get powerup
                            break;
                        else
                            actualFrame = $ - i.frames; -- reduce the amount of frames for the next powerup
                        end
                    end
                end
            else -- bottom half
                if distance <= 4000
                    local actualFrame = leveltime%player.powerlap.bottomtier_L.totalframes; -- take a number based on the amount of frames of the tier
                    -- check if the poweritem frame is higher than the actualFrame
                    -- if so, give the player the corresponding powerup
                    for _,i in ipairs(player.powerlap.bottomtier_L) do
                        if plap.powtoggle[i.id] == false continue end;
                        if i.frames > actualFrame
                            player.powerlap.item = i.id; -- get powerup
                            break;
                        else
                            actualFrame = $ - i.frames; -- reduce the amount of frames for the next powerup
                        end
                    end
                elseif distance >= 4000 and distance <= 8000
                    local actualFrame = leveltime%player.powerlap.bottomtier_M.totalframes; -- take a number based on the amount of frames of the tier
                    -- check if the poweritem frame is higher than the actualFrame
                    -- if so, give the player the corresponding powerup
                    for _,i in ipairs(player.powerlap.bottomtier_M) do
                        if plap.powtoggle[i.id] == false continue end;
                        if i.frames > actualFrame
                            player.powerlap.item = i.id; -- get powerup
                            break;
                        else
                            actualFrame = $ - i.frames; -- reduce the amount of frames for the next powerup
                        end
                    end
                else
                    local actualFrame = leveltime%player.powerlap.bottomtier_H.totalframes; -- take a number based on the amount of frames of the tier
                    -- check if the poweritem frame is higher than the actualFrame
                    -- if so, give the player the corresponding powerup
                    for _,i in ipairs(player.powerlap.bottomtier_H) do
                        if plap.powtoggle[i.id] == false continue end;
                        if i.frames > actualFrame
                            player.powerlap.item = i.id; -- get powerup
                            break;
                        else
                            actualFrame = $ - i.frames; -- reduce the amount of frames for the next powerup
                        end
                    end
                end
            end
            --if player.kartstuff[k_position] == 1 player.powerlap.item = 99; player.powerlap.powtime = TICRATE * 2 end -- no powerup for 1st
            if player.powerlap.item == 0 player.powerlap.item = 99 player.powerlap.powtime = TICRATE * 2 end;
            -- debug always get powerup
            --player.powerlap.item = plap.powitems.protectshield;

            -- for the hud
            player.powerlap.hudtime = TICRATE * 10
        end
        
        
        -- lap check
        if player.laps > player.powerlap.lastlap

            -- set timer for giving a powerup
            if player.powerlap.item == 0 player.powerlap.rolltimer = TICRATE * 3 end;

            -- give time bonus for used powerups
            if player.powerlap.inuse == true

                if player.powerlap.item == 1 -- mini boost
                    player.powerlap.powtime = $ + TICRATE * 5
                    --player.kartstuff[k_driftboost] = $ + TICRATE * 5
                elseif player.powerlap.item == 2 -- long boost
                    player.powerlap.powtime = $ + TICRATE * 10
                    --player.kartstuff[k_driftboost] = $ + TICRATE * 10
                elseif player.powerlap.item == 4 -- mini hyuu
                    player.powerlap.powtime = $ + TICRATE * 7
                elseif player.powerlap.item == 5 -- banana rain
                player.powerlap.powtime = $ + TICRATE * 2
                elseif player.powerlap.item == 9 -- faster spark
                    player.powerlap.powtime = $ + TICRATE * 8
                elseif player.powerlap.item == 6 -- punch bumper
                    player.powerlap.powtime = $ + TICRATE * 7
                elseif player.powerlap.item == 11 -- curse attack
                    player.powerlap.powtime = $ + TICRATE * 15
                end
                

            end
            
            player.powerlap.lastlap = player.laps;
        end

        
    end
    end
end)